﻿using System;
using System.Collections.Generic;
using System.Linq;
//////////////////////////////////////////////////
//                 General.cs                   //
//         Part of RebornCo by kaihaider        //
//////////////////////////////////////////////////
using System.Threading.Tasks;
using System.Windows.Media;
using Buddy.Coroutines;
using ff14bot;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Managers;
using RebornCo.Helpers;
using RebornCo.Settings;

namespace RebornCo.Rotations
{
    public partial class Routines : RebornCoRoutine
    {
        public override void OnInitialize()
        {
            GeneralSetting._instance = new GeneralSetting();
            RogueSetting._instance = new RogueSetting();
            DragoonSetting._instance = new DragoonSetting();
            PugSetting._instance = new PugSetting();
            //else WindowSettings = new CoreSettings();
        }
        public static PugSetting PugSettings
        {
            get { return WindowSettings as PugSetting; }
        }
        public static DragoonSetting DragoonSettings
        {
            get { return WindowSettings as DragoonSetting; }
        }
        public static RogueSetting RogueSettings
        {
            get { return WindowSettings as RogueSetting; }
        }
        public static GeneralSetting GeneralSettings
        {
            get { return WindowSettings as GeneralSetting; }
        }    
        public static bool Gcd;
        public static async Task<bool> DefaultRestBehavior(float CurrentEnergy)
        {
            if (Core.Player.CurrentHealthPercent < WindowSettings.RestHealthDone ||
                CurrentEnergy < WindowSettings.RestEnergyDone)
            {
                Logging.Write(Colors.OrangeRed, "[RebornCo] Resting");
                if (MovementManager.IsMoving && (!Core.Me.HasAura("Sprint"))) await Coroutine.ExternalTask(Task.Run<bool>(() => Movement.StopMove()));
                Resting = true;
                return true;
            }
            else
            {
                Resting = false;
                return false;
            }
        }
    }
}
